<?php
defined('_JEXEC') or die('Restricted access');

defined('DS') or define('DS', DIRECTORY_SEPARATOR);
if (!class_exists('vmPSPlugin')) {
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}
if (!class_exists('OpayGateway')) {
    require(VMPATH_ROOT . DS . 'plugins' . DS . 'vmpayment' . DS . 'opay' . DS . 'opay' . DS . 'lib' . DS . 'opay_8.1.gateway.inc.php');
}

class plgVmPaymentOPAY extends vmPSPlugin
{
    private $selectedChannel = '';

    public function __construct(& $subject, $config)
    {
        parent::__construct($subject, $config);

        $this->_loggable = true;
        $this->tableFields = array_keys($this->getTableSQLFields());
        $this->_tablepkey = 'id';
        $this->_tableId = 'id';
        $varsToPush = $this->getVarsToPush();
        $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
    }

    /**
     * Create the table for this plugin if it does not yet exist.
     */
    public function getVmPluginCreateTableSQL()
    {
        return $this->createTableSQL('Payment OPAY Table');
    }

    public function getTableSQLFields()
    {
        $SQLfields = array(
            'id'                          => 'int(1) UNSIGNED NOT NULL AUTO_INCREMENT',
            'virtuemart_order_id'         => 'int(1) UNSIGNED',

            // OPAY response
            'opay_status'                 => 'tinyint(1)',
            'opay_transaction_id'         => 'varchar(10)',
            'opay_p_token'                => 'varchar(100)',
            'opay_p_amount'               => 'int(10)',
            'opay_p_currency'             => 'char(3)',
            'opay_p_channel'              => 'varchar(30)',
            'opay_p_bank'                 => 'varchar(30)',
        );
        return $SQLfields;
    }

    /**
     * Added Index and removed engine
     */
    protected function createTableSQL($tableComment,$tablesFields=0)
    {
        $query = "CREATE TABLE IF NOT EXISTS `" . $this->_tablename . "` (";
        if(!empty($tablesFields)){
            foreach ($tablesFields as $fieldname => $fieldtype) {
                $query .= '`' . $fieldname . '` ' . $fieldtype . " , ";
            }
        } else {
            $SQLfields = $this->getTableSQLFields ();
            $loggablefields = $this->getTableSQLLoggablefields ();
            foreach ($SQLfields as $fieldname => $fieldtype) {
                $query .= '`' . $fieldname . '` ' . $fieldtype . " , ";
            }
            foreach ($loggablefields as $fieldname => $fieldtype) {
                $query .= '`' . $fieldname . '` ' . $fieldtype . ", ";
            }
        }

        $query .= " PRIMARY KEY (`id`), UNIQUE KEY `virtuemart_order_id_opay` (`virtuemart_order_id`)
        ) DEFAULT CHARSET=utf8 COMMENT='" . $tableComment . "' AUTO_INCREMENT=1 ;";
        return $query;
    }

    public function plgVmConfirmedOrder($cart, $order)
    {
        if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        if (!class_exists('vmCrypt')) {
            require(VMPATH_ADMIN . DS . 'helpers' . DS . 'vmcrypt.php');
        }
        if (!class_exists ('VirtueMartModelOrders')) {
            require(VMPATH_ADMIN . DS . 'models' . DS . 'orders.php');
        }
        if (!class_exists('OpayGateway')) {
            require(VMPATH_ROOT . DS . 'plugins' . DS . 'vmpayment' . DS . 'opay' . DS . 'opay' . DS . 'lib' . DS . 'opay_8.1.gateway.inc.php');
        }

        VmConfig::loadJLang('com_virtuemart',true);
        VmConfig::loadJLang('com_virtuemart_orders', true);

        $virtuemart_order_id = $order['details']['BT']->virtuemart_order_id;

        // Storing plugin data to table
        // No duplicates allowed
        if (!$this->getDataByOrderId($virtuemart_order_id)) {
            $dbValues['virtuemart_order_id'] = $virtuemart_order_id;
            $this->storePSPluginInternalData($dbValues);
        }

        // Updating order status
        $modelOrders = VmModel::getModel ('orders');
        $order['order_status'] = $method->status_pending;
        $order['customer_notified'] = 0;
        $order['comments'] = '';
        $modelOrders->updateStatusForOneOrder($virtuemart_order_id, $order, true);

        // Redirect to OPAY
        $opay = new OpayGateway();
        if (!$this->setOpayAuthentication($method, $opay)) {
            $this->redirectToCart();
        }

        // Getting parameters needed for redirect
        $orderCurrencyID = $order['details']['BT']->order_currency;
        $orderCurrencyCode3 = shopFunctions::getCurrencyByID($orderCurrencyID, 'currency_code_3');
        $orderTotal = vmPSPlugin::getAmountInCurrency($order['details']['BT']->order_total, $orderCurrencyID);
        $country = $this->getCountryCode($cart);
        $langCode = $this->getLangCode();
        // Needed for pass_through_channel_name param
        if ($method->show_payment_methods == 'in_checkout' || $method->show_payment_methods == 'in_checkout_grouped') {
            $this->loadCustomerData($method->virtuemart_paymentmethod_id);
        }

        $paramsArray = array(
            'website_id' => $method->website_id,
            'order_nr' => $order['details']['BT']->order_number,
            'redirect_url' => JRoute::_(JUri::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id),
            'web_service_url' => JRoute::_(JUri::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&format=raw&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id),
            'standard' => 'opay_8.1',
            'language' => $langCode,
            'country' => $country,
            'amount' => intval(number_format($orderTotal['value'], 2, '', '')),
            'currency' => $orderCurrencyCode3,
            'c_email' => $order['details']['BT']->email,
            'pass_through_channel_name' => $this->selectedChannel,
            'test' => ($method->test_mode == 1) ? $method->user_id : ''
        );

        // Removing cart and customer data from session
        $cart = VirtueMartCart::getCart();
        $cart->emptyCart();
        $this->clearCustomerData();

        // Redirect
        $paramsArray = $opay->signArrayOfParameters($paramsArray);
        $html = $opay->generatetAutoSubmitForm('https://gateway.opay.lt/pay/', $paramsArray);
        $session = JFactory::getSession();
        $session->set('opay-redirect_html', $html, 'vm');
        $url = JURI::base() . DS . 'plugins' . DS . 'vmpayment' . DS . 'opay' . DS . 'opay' . DS . 'views' . DS . 'redirect.php';
        header('Location: ' . $url);

        return true;
    }

    /**
     * Before creating an order check if payment channel is selected
     */
    public function plgVmOnUserOrder($orderData)
    {
        if (!($method = $this->getVmPluginMethod($orderData->virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return null;
        }

        if ($method->show_payment_methods == 'in_checkout' || $method->show_payment_methods == 'in_checkout_grouped') {
            $this->loadCustomerData($method->virtuemart_paymentmethod_id);
            if (empty($this->selectedChannel)) {
                $msg = vmText::_('VMPAYMENT_OPAY_SELECT_PAYEMENT_CHANNEL');
                $this->redirectToCart($msg, 'warning');
            }
        }
    }

    /**
     * Display stored payment data for an order
     */
    public function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id)
    {
        if (!$this->selectedThisByMethodId ($virtuemart_payment_id)) {
            return null; // Another method was selected, do nothing
        }
        if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
            return null;
        }

        VmConfig::loadJLang('com_virtuemart');

        $html = '<table class="adminlist table">' . "\n";
        $html .= $this->getHtmlHeaderBE();
        if ($paymentTable->opay_status == 1) {
            $html .= $this->getHtmlRowBE('VMPAYMENT_OPAY_STATUS', vmText::_('VMPAYMENT_OPAY_STATUS_1'));
            $html .= $this->getHtmlRowBE('VMPAYMENT_OPAY_TRANSACTION_ID', $paymentTable->opay_transaction_id);
            $html .= $this->getHtmlRowBE('VMPAYMENT_OPAY_P_AMOUNT', number_format(($paymentTable->opay_p_amount/100), 2, '.', ' ') . ' ' . $paymentTable->opay_p_currency);
            $html .= $this->getHtmlRowBE('VMPAYMENT_OPAY_P_CHANNEL', $paymentTable->opay_p_channel);
            if (!empty($paymentTable->opay_p_bank)) {
                $html .= $this->getHtmlRowBE('VMPAYMENT_OPAY_P_BANK', $paymentTable->opay_p_bank);
            }
        } elseif ($paymentTable->opay_status == 0) {
            $html .= $this->getHtmlRowBE('VMPAYMENT_OPAY_STATUS', vmText::_('VMPAYMENT_OPAY_STATUS_0'));
        }

        $html .= '</table>' . "\n";
        return $html;
    }

    /**
     * Check if the payment conditions are fulfilled for this payment method
     *
     * @author: Valerie Isaksen
     *
     * @param $cart_prices: cart prices
     * @param $payment
     * @return true: if the conditions are fulfilled, false otherwise
     *
     */
    protected function checkConditions($cart, $method, $cart_prices)
    {
        $this->convert_condition_amount($method);
        $amount = $this->getCartAmount($cart_prices);
        $address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

        // vmdebug('standard checkConditions',  $amount, $cart_prices['salesPrice'],  $cart_prices['salesPriceCoupon']);
        $amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
            OR
            ($method->min_amount <= $amount AND ($method->max_amount == 0)));
        if (!$amount_cond) {
            return FALSE;
        }
        $countries = array();
        if (!empty($method->countries)) {
            if (!is_array ($method->countries)) {
                $countries[0] = $method->countries;
            } else {
                $countries = $method->countries;
            }
        }

        // probably did not gave his BT:ST address
        if (!is_array ($address)) {
            $address = array();
            $address['virtuemart_country_id'] = 0;
        }

        if (!isset($address['virtuemart_country_id'])) {
            $address['virtuemart_country_id'] = 0;
        }
        if (count ($countries) == 0 || in_array ($address['virtuemart_country_id'], $countries) ) {
            return TRUE;
        }

        return FALSE;
    }

    /**
     * Create the table for this plugin if it does not yet exist.
     * This functions checks if the called plugin is active one.
     * When yes it is calling the standard method to create the tables
     *
     * @author Valérie Isaksen
     *
     */
    public function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
    {
        if ($jplugin_id != $this->_jid) {
            return false;
        }
        $method = $this->getPluginMethod(vRequest::getInt('virtuemart_paymentmethod_id'));
        $this->isSetMethodRequiredParams($method);

        return $this->onStoreInstallPluginTable($jplugin_id);
    }

    /**
     * This event is fired after the payment method has been selected. It can be used to store
     * additional payment info in the cart.
     *
     * @param VirtueMartCart $cart: the actual cart
     * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
     *
     */
    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart, &$msg)
    {
        if (!$this->selectedThisByMethodId($cart->virtuemart_paymentmethod_id)) {
            return null; // Another method was selected, do nothing
        }
        if (!($currentMethod = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id))) {
            return false;
        }

        $this->loadCustomerData($currentMethod->virtuemart_paymentmethod_id);

        return $this->OnSelectCheck($cart);
    }

    /**
     * plgVmDisplayListFEPayment
     * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for example
     *
     * @param object  $cart Cart object
     * @param integer $selected ID of the method selected
     * @return boolean True on succes, false on failures, null when this plugin was not selected.
     * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
     *
     */
    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn)
    {
        if ($this->getPluginMethods($cart->vendorId) === 0) {
            if (empty($this->_name)) {
                vmAdminInfo('displayListFE cartVendorId=' . $cart->vendorId);
                $app = JFactory::getApplication ();
                $app->enqueueMessage(vmText::_ ('COM_VIRTUEMART_CART_NO_' . strtoupper ($this->_psType)));
                return false;
            } else {
                return false;
            }
        }

        $html = '';

        foreach ($this->methods as $method) {

            // Backward compatibility
            if(!defined('VM_VERSION') or VM_VERSION < 3){
                $prices = $cart->pricesUnformatted;
            } else {
                $prices = $cart->cartPrices;
            }

            // Restrictions
            if ($this->checkConditions($cart, $method, $prices)) {

                // The price must not be overwritten directly in the cart. Fees and taxes are applied here.
                $methodSalesPrice = $this->setCartPrices($cart, $prices ,$method);

                // Set plugin name
                $method->payment_name = $this->renderPluginName($method);

                // Payment method radio button
                $html .= $this->getPluginHtml($method, $selected, $methodSalesPrice);

                // Load css if needed
                if ($method->show_payment_methods == 'in_checkout_grouped' || $method->show_payment_methods == 'in_checkout') {
                    vmJsApi::css('opay', 'plugins/vmpayment/opay/opay/assets/css');
                }

                // Shows only a method name if this method is not selected
                if (!$this->selectedThisByMethodId($cart->virtuemart_paymentmethod_id)) {
                    continue;
                }

                // Checking required method params
                if (!$this->isSetMethodRequiredParams($method)) {
                    continue;
                }

                $this->loadCustomerData($method->virtuemart_paymentmethod_id);

                if ($method->show_payment_methods == 'in_checkout' || $method->show_payment_methods == 'in_checkout_grouped') {

                    $opay = new OpayGateway();

                    if ($this->setOpayAuthentication($method, $opay)) {

                        $country = $this->getCountryCode($cart);
                        $currencyCode3 = shopFunctions::getCurrencyByID($cart->pricesCurrency, 'currency_code_3');
                        $langCode = $this->getLangCode();

                        $opayParams = array(
                            'website_id' => $method->website_id,
                            'order_nr' => (string)time(), // fake
                            'redirect_url' => JRoute::_(JUri::root() . 'index.php'), // fake
                            'web_service_url' => JRoute::_(JUri::root() . 'index.php'), // fake
                            'standard' => 'opay_8.1',
                            'country' => $country,
                            'language' => $langCode,
                            'amount' => intval(number_format($prices['billTotal'], 2, '', '')),
                            'currency' => $currencyCode3,
                            'test' => $method->user_id
                        );

                        $opayParams = $opay->signArrayOfParameters($opayParams);
                        try {
                            $opayResponse = $opay->webServiceRequest('https://gateway.opay.lt/api/listchannels/', $opayParams);
                        } catch (OpayGatewayException $exc) {}

                        if (count($opayResponse['response']['errors']) > 0) {
                            vmdebug('plgVmDisplayListFEPayment', $opayResponse['response']['errors']);
                        }

                        if (!empty($opayResponse['response']['result'])) {
                            $viewData = array(
                                'virtuemart_paymentmethod_id' => $method->virtuemart_paymentmethod_id,
                                'channels' => $opayResponse['response']['result'],
                                'iconHeight' => $method->icons_height,
                                'selectedChannel' => $this->selectedChannel
                            );
                            if ($method->show_payment_methods == 'in_checkout_grouped') {
                                $html .= $this->renderByLayout('checkoutbanksiconsgrouped', $viewData);
                            } elseif ($method->show_payment_methods == 'in_checkout') {
                                $html .= $this->renderByLayout('checkoutbanksicons', $viewData);
                            }
                        }
                    }
                }
            }
        }

        if (!empty($html)) {
            $htmlIn[] = array($html);
            return true;
        }

        return false;
    }

    /**
     * plgVmOnPaymentResponseReceived
     * This event is fired when the  method returns to the shop after the transaction
     *
     *  the method itself should send in the URL the parameters needed
     * NOTE for Plugin developers:
     *  If the plugin is NOT actually executed (not the selected payment method), this method must return NULL
     *
     * @param int     $virtuemart_order_id : should return the virtuemart_order_id
     * @param text    $html: the html to display
     * @return mixed Null when this method was not selected, otherwise the true or false
     *
     */
    public function plgVmOnPaymentResponseReceived(&$html, &$paymentResponse)
    {
        // The payment itself should send the parameter needed.
        $virtuemart_paymentmethod_id = vRequest::getInt('pm');

        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return null;
        }

        if (!class_exists('VirtueMartCart')) {
            require(VMPATH_SITE . DS . 'helpers' . DS . 'cart.php');
        }
        if (!class_exists('shopFunctionsF')) {
            require(VMPATH_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
        }
        if (!class_exists('VirtueMartModelOrders')) {
            require(VMPATH_ADMIN . DS . 'models' . DS . 'orders.php');
        }

        $opay = new OpayGateway();
        $this->setOpayAuthentication($method, $opay);

        // Getting parameters array from request
        $get = vRequest::getGet();
        $post = vRequest::getPost();

        if (isset($post['encoded'])) {
            $receivedParams = $opay->convertEncodedStringToArrayOfParameters($post['encoded']);
        } elseif (isset($get['encoded'])) {
            $receivedParams = $opay->convertEncodedStringToArrayOfParameters($get['encoded']);
        } elseif (isset($post['password_signature']) || isset($post['rsa_signature'])) {
            $receivedParams = $post;
        } elseif (isset($get['password_signature']) || isset($get['rsa_signature'])) {
            $receivedParams = $get;
        } else {
            return null; // No request parameters
        }

        if (!$opay->verifySignature($receivedParams)) {
            return null; // Wrong signature
        }

        // Checking if order exist
        if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($receivedParams['order_nr']))) {
            return null; // No such order
        }
        if (!($payment = $this->getDataByOrderId($virtuemart_order_id))) {
            return null; // Can't get order data
        }

        // Storing plugin data to table
        $internalData = (array)$payment;
        vmdebug('plgVmOnPaymentResponseReceived', $payment);
        // Preparing data for known collumns
        foreach ($receivedParams as $key => $value) {
            if (array_key_exists('opay_' . $key, $internalData)) {
                $internalData['opay_' . $key] = $value;
            }
        }
        // Old data gets overwritten here
        $this->storePSPluginInternalData($internalData, $this->_tablepkey);

        // Getting order
        $modelOrders = VmModel::getModel('orders');
        $order = $modelOrders->getOrder($virtuemart_order_id);

        // Updating order status if order is pending
        if ($order['details']['BT']->order_status == $method->status_pending) {

            $newStatus = '';

            if ($receivedParams['status'] == 1) {

                // Getting order currency and total amount
                $orderCurrencyID = $order['details']['BT']->order_currency;
                $orderCurrencyCode3 = shopFunctions::getCurrencyByID($orderCurrencyID, 'currency_code_3');
                $orderTotal = vmPSPlugin::getAmountValueInCurrency($order['details']['BT']->order_total, $orderCurrencyID);
                $orderTotalInCents = intval(number_format($orderTotal, 2, '', ''));

                // Checking if paid currency/amount matches order currency/amount
                if (strcasecmp($orderCurrencyCode3, $receivedParams['p_currency']) == 0
                    && $orderTotalInCents == $receivedParams['p_amount']) {

                    $newStatus = $method->status_success;
                }
            } elseif ($receivedParams['status'] == 0) {
                $newStatus = $method->status_canceled;
            }

            if (!empty($newStatus)) {
                $order['order_status'] = $newStatus;
                $order['customer_notified'] = 1;
                $order['comments'] = '';
                $modelOrders->updateStatusForOneOrder($virtuemart_order_id, $order);
            }
        }

        // Responding to OPAY request
        if (vRequest::getString('format') == 'raw') { // Request from server
            // Preventing joomla output. No more actions needed.
            exit('OK');
        } else { // Request from browser
            VmConfig::loadJLang('com_virtuemart', true);
            VmConfig::loadJLang('com_virtuemart_orders', true);

            // Render layout
            $viewData = array(
                'order' => $order,
                'opay_params' => $receivedParams
            );
            $html = $this->renderByLayout('opayresponse', $viewData);
        }

        return true;
    }

    /**
     * plgVmonSelectedCalculatePricePayment
     * Calculate the price (value, tax_id) of the selected method
     * It is called by the calculator
     * This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
     * @author Valerie Isaksen
     * @cart: VirtueMartCart the current cart
     * @cart_prices: array the new cart prices
     * @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
     *
     */
    public function plgVmonSelectedCalculatePricePayment (VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
    {
        return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    public function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId)
    {
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return NULL; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return FALSE;
        }
        $this->getPaymentCurrency ($method);

        $paymentCurrencyId = $method->payment_currency;
        return;
    }

    /**
     * @param $virtuemart_paymentmethod_id
     * @param $paymentCurrencyId
     * @return bool|null
     */
    public function plgVmgetEmailCurrency($virtuemart_paymentmethod_id, $virtuemart_order_id, &$emailCurrencyId)
    {
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return NULL; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return FALSE;
        }
        if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
            // JError::raiseWarning(500, $db->getErrorMsg());
            return '';
        }
        if (empty($payments[0]->email_currency)) {
            $vendorId = 1; //VirtueMartModelVendor::getLoggedVendor();
            $db = JFactory::getDBO();
            $q = 'SELECT   `vendor_currency` FROM `#__virtuemart_vendors` WHERE `virtuemart_vendor_id`=' . $vendorId;
            $db->setQuery($q);
            $emailCurrencyId = $db->loadResult();
        } else {
            $emailCurrencyId = $payments[0]->email_currency;
        }
    }

    /**
     * This event is fired during the checkout process. It can be used to validate the
     * method data as entered by the user.
     *
     * @return boolean True when the data was valid, false otherwise. If the plugin is not activated, it should return null.
     */
    public function plgVmOnCheckoutCheckDataPayment(VirtueMartCart $cart)
    {
        if (!$this->selectedThisByMethodId($cart->virtuemart_paymentmethod_id)) {
            return null; // Another method was selected, do nothing
        }
        if (!($this->_currentMethod = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id))) {
            return false;
        }

        return true;
    }

    /**
     * plgVmOnCheckAutomaticSelectedPayment
     * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
     * The plugin must check first if it is the correct type
     *
     * @author Valerie Isaksen
     * @param VirtueMartCart cart: the cart object
     * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
     *
     */
    public function plgVmOnCheckAutomaticSelectedPayment (VirtueMartCart $cart, array $cart_prices = array(), &$paymentCounter)
    {
        return $this->onCheckAutomaticSelected($cart, $cart_prices, $paymentCounter);
    }

    /**
     * This method is fired when showing the order details in the frontend.
     * It displays the method-specific data.
     *
     * @param integer $order_id The order ID
     * @return mixed Null for methods that aren't active, text (HTML) otherwise
     */
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name)
    {
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!($this->selectedThisByMethodId($virtuemart_paymentmethod_id))) {
            return null;
        }
        $payment_name = $this->renderPluginName($method);
    }

    /**
     * This method is fired when showing when priting an Order
     * It displays the the payment method-specific data.
     *
     * @param integer $_virtuemart_order_id The order ID
     * @param integer $method_id  method used for this order
     * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
     * @author Valerie Isaksen
     */
    public function plgVmonShowOrderPrintPayment($order_number, $method_id)
    {
        return $this->onShowOrderPrint ($order_number, $method_id);
    }

    public function plgVmDeclarePluginParamsPaymentVM3(&$data)
    {
        return $this->declarePluginParams('payment', $data);
    }

    /**
     * For backward compatibility
     */
    public function plgVmDeclarePluginParamsPayment($name, $id, &$data)
    {
        return $this->declarePluginParams('payment', $name, $id, $data);
    }

    public function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
    {
        return $this->setOnTablePluginParams($name, $id, $table);
    }

    /**
     * Getting payment method name from OPAY. Also removing payment logos from name.
     */
    public function renderPluginName($method)
    {
        $name = $this->getSettings($method, 'payment_gateway_name');
        if (empty($name)) {
            $name = 'OPAY';
        }

        $htmlDesc = '';
        if (!empty($method->payment_desc)) {
            $htmlDesc = '<span class="' . $this->_type . '_description">' . $method->payment_desc . '</span>';
        }
        $htmlName = '<span class="' . $this->_type . '_name">' . $name . '</span>' . $htmlDesc;
        return $htmlName;
    }

    // PRIVATE FUNCTIONS

    private function setOpayAuthentication($method, &$opayGateway)
    {
        if ($method->signature_type == 'rsa') {
            $opayGateway->setMerchantRsaPrivateKey($method->rsa_private_key);
            $opayGateway->setOpayCertificate($method->rsa_opay_certificate);
        } elseif ($method->signature_type == 'password') {
            $opayGateway->setSignaturePassword($method->signature_password);
        } else {
            return false;
        }
        return true;
    }

    private function getSettings($method, $name = '')
    {
        if (empty($this->opaySettings)) {

            if (!class_exists('VirtueMartCart')) {
                require(VMPATH_SITE . DS . 'helpers' . DS . 'cart.php');
            }

            $opay = new OpayGateway;
            $this->setOpayAuthentication($method, $opay);

            // Getting language/country codes
            $cart = VirtueMartCart::getCart();
            $country = $this->getCountryCode($cart);
            $lang = $this->getLangCode();

            $paramsArray = array(
                'service_name' => 'getSettings',
                'website_id'   => $method->website_id,
                'language'     => $lang,
                'country'      => $country
            );

            try {
                $paramsArray = $opay->signArrayOfParameters($paramsArray);
                $array = $opay->webServiceRequest('https://gateway.opay.lt/api/websites/', $paramsArray);
            } catch (OpayGatewayException $e) {
                $array = array();
            }

            if (!empty($array['response']['result'])) {
                $this->opaySettings = $array['response']['result'];
            }
        }

        if ($name != '') {
            return (isset($this->opaySettings[$name])) ? $this->opaySettings[$name] : '';
        } else {
            return (!empty($this->opaySettings)) ? $this->opaySettings : array();
        }
    }

    private function loadCustomerData($method_id)
    {
        // Load session data
        $session = JFactory::getSession();
        $sessionData = $session->get('opay', null, 'vm');
        if (!empty($sessionData)) {
            $data = (object)json_decode($sessionData, true);
            $this->selectedChannel = $data->channel;
        }

        // Load POST data
        $selectedChannel = vRequest::getString('channel_' . $method_id, '');
        if ($selectedChannel) {
            $this->selectedChannel = $selectedChannel;
        }

        $this->saveCustomerData();

        return true;
    }

    private function saveCustomerData()
    {
        // Save to session
        $session = JFactory::getSession();
        $sessionData = new stdClass();
        $sessionData->channel = $this->selectedChannel;

        $session->set('opay', json_encode($sessionData), 'vm');
    }

    private function clearCustomerData()
    {
        $session = JFactory::getSession();
        $session->clear('opay', 'vm');
    }

    private function isSetMethodRequiredParams($method)
    {
        $set = true;

        if (empty($method->website_id)) {
            $text = vmText::sprintf('VMPAYMENT_OPAY_PARAMETER_REQUIRED', vmText::_('VMPAYMENT_OPAY_WEBSITE_ID'));
            vmError($text, $text);
            $set = false;
        }
        if ($method->signature_type == 'password') {
            if (empty($method->signature_password)) {
                $text = vmText::sprintf('VMPAYMENT_OPAY_PARAMETER_REQUIRED', vmText::_('VMPAYMENT_OPAY_SIGNATURE_PASSWORD'));
                vmError($text, $text);
                $set = false;
            }
        } elseif ($method->signature_type == 'rsa'){
            if (empty($method->rsa_private_key)) {
                $text = vmText::sprintf('VMPAYMENT_OPAY_PARAMETER_REQUIRED', vmText::_('VMPAYMENT_OPAY_RSA_PRIVATE_KEY'));
                vmError($text, $text);
                $set = false;
            }
            if (empty($method->rsa_opay_certificate)) {
                $text = vmText::sprintf('VMPAYMENT_OPAY_PARAMETER_REQUIRED', vmText::_('VMPAYMENT_OPAY_RSA_OPAY_CERTIFICATE'));
                vmError($text, $text);
                $set = false;
            }
        }
        if ($method->test_mode == 1) {
            if (empty($method->user_id)) {
                $text = vmText::sprintf('VMPAYMENT_OPAY_PARAMETER_REQUIRED', vmText::_('VMPAYMENT_OPAY_USER_ID'));
                vmError($text, $text);
                $set = false;
            }
        }

        return $set;
    }

    private function redirectToCart($msg = '', $msgType = '')
    {
        $msgType = empty($msgType) ? 'message' : $msgType;
        $app = JFactory::getApplication();
        $app->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart&Itemid=' . vRequest::getInt('Itemid'), false), $msg, $msgType);
    }

    private function getLangCode()
    {
        $lang = JFactory::getLanguage();
        $tag = $lang->getTag();
        $langCode = substr($tag, 0, 2);
        return $langCode;
    }

    private function getCountryCode($cart)
    {
        $address = ($cart->ST == 0) ? $cart->BT : $cart->ST;
        $country = '';
        if (isset($address['virtuemart_country_id'])) {
            $country = ShopFunctions::getCountryByID($address['virtuemart_country_id'], 'country_2_code');
        }
        return $country;
    }
}
